/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.events;

import org.eclipse.emf.common.util.EList;

import org.eclipse.viatra.cep.core.metamodels.automaton.EventContext;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Complex Event Pattern</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getOperator <em>Operator</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getTimewindow <em>Timewindow</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getContainedEventPatterns <em>Contained Event Patterns</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getEventContext <em>Event Context</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getComplexEventPattern()
 * @model
 * @generated
 */
public interface ComplexEventPattern extends EventPattern {
	/**
	 * Returns the value of the '<em><b>Operator</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operator</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operator</em>' containment reference.
	 * @see #setOperator(ComplexEventOperator)
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getComplexEventPattern_Operator()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ComplexEventOperator getOperator();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getOperator <em>Operator</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operator</em>' containment reference.
	 * @see #getOperator()
	 * @generated
	 */
	void setOperator(ComplexEventOperator value);

	/**
	 * Returns the value of the '<em><b>Timewindow</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Timewindow</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Timewindow</em>' containment reference.
	 * @see #setTimewindow(Timewindow)
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getComplexEventPattern_Timewindow()
	 * @model containment="true"
	 * @generated
	 */
	Timewindow getTimewindow();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getTimewindow <em>Timewindow</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Timewindow</em>' containment reference.
	 * @see #getTimewindow()
	 * @generated
	 */
	void setTimewindow(Timewindow value);

	/**
	 * Returns the value of the '<em><b>Contained Event Patterns</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra.cep.core.metamodels.events.EventPatternReference}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Contained Event Patterns</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Contained Event Patterns</em>' containment reference list.
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getComplexEventPattern_ContainedEventPatterns()
	 * @model containment="true"
	 * @generated
	 */
	EList<EventPatternReference> getContainedEventPatterns();

	/**
	 * Returns the value of the '<em><b>Event Context</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.viatra.cep.core.metamodels.automaton.EventContext}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Context</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Context</em>' attribute.
	 * @see org.eclipse.viatra.cep.core.metamodels.automaton.EventContext
	 * @see #setEventContext(EventContext)
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getComplexEventPattern_EventContext()
	 * @model
	 * @generated
	 */
	EventContext getEventContext();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.events.ComplexEventPattern#getEventContext <em>Event Context</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Context</em>' attribute.
	 * @see org.eclipse.viatra.cep.core.metamodels.automaton.EventContext
	 * @see #getEventContext()
	 * @generated
	 */
	void setEventContext(EventContext value);

} // ComplexEventPattern
