/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.events;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.EventModel#getEventPatterns <em>Event Patterns</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getEventModel()
 * @model
 * @generated
 */
public interface EventModel extends EObject {
	/**
	 * Returns the value of the '<em><b>Event Patterns</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra.cep.core.metamodels.events.EventPattern}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra.cep.core.metamodels.events.EventPattern#getEventModel <em>Event Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Patterns</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Patterns</em>' containment reference list.
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getEventModel_EventPatterns()
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventPattern#getEventModel
	 * @model opposite="eventModel" containment="true"
	 * @generated
	 */
	EList<EventPattern> getEventPatterns();

} // EventModel
