/**
 * Copyright (c) 2004-2015, Istvan David, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Istvan David - initial API and implementation
 */
package org.eclipse.viatra.cep.core.metamodels.events;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Pattern Reference</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.EventPatternReference#getEventPattern <em>Event Pattern</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.EventPatternReference#getMultiplicity <em>Multiplicity</em>}</li>
 *   <li>{@link org.eclipse.viatra.cep.core.metamodels.events.EventPatternReference#getParameterSymbolicNames <em>Parameter Symbolic Names</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getEventPatternReference()
 * @model
 * @generated
 */
public interface EventPatternReference extends EObject {
	/**
	 * Returns the value of the '<em><b>Event Pattern</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Event Pattern</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Pattern</em>' containment reference.
	 * @see #setEventPattern(EventPattern)
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getEventPatternReference_EventPattern()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EventPattern getEventPattern();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.events.EventPatternReference#getEventPattern <em>Event Pattern</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Event Pattern</em>' containment reference.
	 * @see #getEventPattern()
	 * @generated
	 */
	void setEventPattern(EventPattern value);

	/**
	 * Returns the value of the '<em><b>Multiplicity</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Multiplicity</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Multiplicity</em>' containment reference.
	 * @see #setMultiplicity(AbstractMultiplicity)
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getEventPatternReference_Multiplicity()
	 * @model containment="true" required="true"
	 * @generated
	 */
	AbstractMultiplicity getMultiplicity();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.cep.core.metamodels.events.EventPatternReference#getMultiplicity <em>Multiplicity</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Multiplicity</em>' containment reference.
	 * @see #getMultiplicity()
	 * @generated
	 */
	void setMultiplicity(AbstractMultiplicity value);

	/**
	 * Returns the value of the '<em><b>Parameter Symbolic Names</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parameter Symbolic Names</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parameter Symbolic Names</em>' attribute list.
	 * @see org.eclipse.viatra.cep.core.metamodels.events.EventsPackage#getEventPatternReference_ParameterSymbolicNames()
	 * @model
	 * @generated
	 */
	EList<String> getParameterSymbolicNames();

} // EventPatternReference
