/**
 */
package org.eclipse.viatra.query.runtime.rete.recipes;

import org.eclipse.emf.common.util.EMap;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Production Recipe</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The production node represents the output of the Rete network,
 * from which the results of a query can be read.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.ProductionRecipe#getMappedIndices <em>Mapped Indices</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.ProductionRecipe#getPattern <em>Pattern</em>}</li>
 *   <li>{@link org.eclipse.viatra.query.runtime.rete.recipes.ProductionRecipe#getPatternFQN <em>Pattern FQN</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getProductionRecipe()
 * @model
 * @generated
 */
public interface ProductionRecipe extends MultiParentNodeRecipe {
	/**
	 * Returns the value of the '<em><b>Mapped Indices</b></em>' map.
	 * The key is of type {@link java.lang.String},
	 * and the value is of type {@link java.lang.Integer},
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * String -> Index map.
	 * Indicates the positions of parameters.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mapped Indices</em>' map.
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getProductionRecipe_MappedIndices()
	 * @model mapType="org.eclipse.viatra.query.runtime.rete.recipes.StringIndexMapEntry<org.eclipse.emf.ecore.EString, org.eclipse.viatra.query.runtime.rete.recipes.Index>"
	 * @generated
	 */
	EMap<String, Integer> getMappedIndices();

	/**
	 * Returns the value of the '<em><b>Pattern</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Traceability link to defining pattern object (from EMFPatternLanguage)
	 * TODO unused?
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Pattern</em>' attribute.
	 * @see #setPattern(Object)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getProductionRecipe_Pattern()
	 * @model unique="false"
	 * @generated
	 */
	Object getPattern();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.ProductionRecipe#getPattern <em>Pattern</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pattern</em>' attribute.
	 * @see #getPattern()
	 * @generated
	 */
	void setPattern(Object value);

	/**
	 * Returns the value of the '<em><b>Pattern FQN</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pattern FQN</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pattern FQN</em>' attribute.
	 * @see #setPatternFQN(String)
	 * @see org.eclipse.viatra.query.runtime.rete.recipes.RecipesPackage#getProductionRecipe_PatternFQN()
	 * @model
	 * @generated
	 */
	String getPatternFQN();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.query.runtime.rete.recipes.ProductionRecipe#getPatternFQN <em>Pattern FQN</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pattern FQN</em>' attribute.
	 * @see #getPatternFQN()
	 * @generated
	 */
	void setPatternFQN(String value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation" unique="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return this.getMappedIndices().size();'"
	 * @generated
	 */
	int getArity();

} // ProductionRecipe
